from z3 import *
set_param(proof=True)
try:
	CONRT_EtherStore= DeclareSort('CONRT_EtherStore')
	map= DeclareSort('map')
	EtherStore_balances= Function('EtherStore_balances',CONRT_EtherStore,map)
	total= Int('total')
	address= DeclareSort('address')
	msg_sender= Const('msg_sender',address)
	d1FaddressTuint256mapping= Function('d1FaddressTuint256mapping',map,address,IntSort())
	bal= Int('bal')
	void= DeclareSort('void')
	_1solidity= Const('_1solidity',void)
	sent= Const('sent',BoolSort())
	_2solidity= Const('_2solidity',void)
	string= DeclareSort('string')
	error= Const('error',string)
	TUPLE= DeclareSort('TUPLE')
	TUPLE_0= Const('TUPLE_0',TUPLE)
	LOW_LEVEL_CALL_call= Function('LOW_LEVEL_CALL_call',address,IntSort(),TUPLE)
	UNPACK2DTUPLETbool= Function('UNPACK2DTUPLETbool',TUPLE,IntSort(),BoolSort())
	lv_1var= Const('lv_1var',BoolSort())
	lv_2var= Const('lv_2var',BoolSort())
	_5reentrancy_verifier= Int('_5reentrancy_verifier')
	_6reentrancy_verifier= Int('_6reentrancy_verifier')
	IsEtherStore= Function('IsEtherStore',CONRT_EtherStore,BoolSort())
	EtherStore_balances1= Function('EtherStore_balances1',CONRT_EtherStore,map)
	error1= Const('error1',string)
	bal1= Int('bal1')
	TUPLE_01= Const('TUPLE_01',TUPLE)
	msg_sender1= Const('msg_sender1',address)
	LOW_LEVEL_CALL_call1= Function('LOW_LEVEL_CALL_call1',address,IntSort(),TUPLE)
	sent1= Const('sent1',BoolSort())
	UNPACK2DTUPLETbool1= Function('UNPACK2DTUPLETbool1',TUPLE,IntSort(),BoolSort())
	lv_1var1= Const('lv_1var1',BoolSort())
	total1= Int('total1')
	d1FaddressTuint256mapping1= Function('d1FaddressTuint256mapping1',map,address,IntSort())
	_1solidity1= Const('_1solidity1',void)
	_2solidity1= Const('_2solidity1',void)
	lv_2var1= Const('lv_2var1',BoolSort())
	_5reentrancy_verifier1= Int('_5reentrancy_verifier1')
	_6reentrancy_verifier1= Int('_6reentrancy_verifier1')
	_y39= Const('_y39',CONRT_EtherStore)
	_y40= Const('_y40',address)
	_y41= Int('_y41')
	_y42= Const('_y42',TUPLE)
	_y43= Int('_y43')
	_y44= Const('_y44',CONRT_EtherStore)
	_y45= Const('_y45',map)
	_y46= Const('_y46',address)
	_y47= Const('_y47',CONRT_EtherStore)
	_y48= Const('_y48',CONRT_EtherStore)
	_y49= Const('_y49',CONRT_EtherStore)
	_y50= Const('_y50',CONRT_EtherStore)
	_y51= Const('_y51',CONRT_EtherStore)
	_y52= Const('_y52',CONRT_EtherStore)
	_y53= Const('_y53',CONRT_EtherStore)
	_y54= Const('_y54',CONRT_EtherStore)
	_y55= Const('_y55',CONRT_EtherStore)
	_y56= Const('_y56',CONRT_EtherStore)
	_s=Solver()
	_s.set("timeout",50000)
	_s.add(ForAll([_y39],EtherStore_balances1(_y39)==EtherStore_balances(_y39)))
	_s.add(_1solidity1==_1solidity)
	_s.add(_2solidity1==_2solidity)
	_s.add(ForAll([_y40,_y41],LOW_LEVEL_CALL_call1(_y40,_y41)==LOW_LEVEL_CALL_call(_y40,_y41)))
	_s.add(ForAll([_y42,_y43],UNPACK2DTUPLETbool1(_y42,_y43)==UNPACK2DTUPLETbool(_y42,_y43)))
	_s.add(ForAll([_y44,msg_sender],total1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y44),msg_sender))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),d1FaddressTuint256mapping(EtherStore_balances(_y44),msg_sender),d1FaddressTuint256mapping(EtherStore_balances(_y44),msg_sender))),0),((If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y44),msg_sender))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,d1FaddressTuint256mapping(EtherStore_balances(_y44),msg_sender)),0),total + 2,total),total),total + 1))+(2)),If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y44),msg_sender))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,d1FaddressTuint256mapping(EtherStore_balances(_y44),msg_sender)),0),total + 2,total),total),total + 1)),total),total + 1)))
	_s.add(ForAll([_y45,_y46,_y47,msg_sender],d1FaddressTuint256mapping1(_y45,_y46)==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y47),msg_sender))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),d1FaddressTuint256mapping(EtherStore_balances(_y47),msg_sender),d1FaddressTuint256mapping(EtherStore_balances(_y47),msg_sender))),0),If(And(((_y45)==(EtherStore_balances(_y47))),((_y46)==(msg_sender))),0,If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y47),msg_sender))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,d1FaddressTuint256mapping(EtherStore_balances(_y47),msg_sender)),0),If(And(((_y45)==(EtherStore_balances(_y47))),((_y46)==(msg_sender))),0,d1FaddressTuint256mapping(_y45,_y46)),d1FaddressTuint256mapping(_y45,_y46)),d1FaddressTuint256mapping(_y45,_y46)),d1FaddressTuint256mapping(_y45,_y46))),If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y47),msg_sender))>(0)),If(UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,d1FaddressTuint256mapping(EtherStore_balances(_y47),msg_sender)),0),If(And(((_y45)==(EtherStore_balances(_y47))),((_y46)==(msg_sender))),0,d1FaddressTuint256mapping(_y45,_y46)),d1FaddressTuint256mapping(_y45,_y46)),d1FaddressTuint256mapping(_y45,_y46)),d1FaddressTuint256mapping(_y45,_y46))),d1FaddressTuint256mapping(_y45,_y46)),d1FaddressTuint256mapping(_y45,_y46))))
	_s.add(ForAll([_y48,msg_sender],bal1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y48),msg_sender))>(0)),If(((total <= 100)==(True)),d1FaddressTuint256mapping(EtherStore_balances(_y48),msg_sender),d1FaddressTuint256mapping(EtherStore_balances(_y48),msg_sender)),d1FaddressTuint256mapping(EtherStore_balances(_y48),msg_sender)),bal)))
	_s.add(ForAll([_y49,msg_sender],sent1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y49),msg_sender))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),d1FaddressTuint256mapping(EtherStore_balances(_y49),msg_sender),d1FaddressTuint256mapping(EtherStore_balances(_y49),msg_sender))),0),sent),sent)))
	_s.add(ForAll([_y51,msg_sender],TUPLE_01==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y51),msg_sender))>(0)),LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),d1FaddressTuint256mapping(EtherStore_balances(_y51),msg_sender),d1FaddressTuint256mapping(EtherStore_balances(_y51),msg_sender))),TUPLE_0),TUPLE_0)))
	_s.add(ForAll([_y52,msg_sender],lv_1var1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y52),msg_sender))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),d1FaddressTuint256mapping(EtherStore_balances(_y52),msg_sender),d1FaddressTuint256mapping(EtherStore_balances(_y52),msg_sender))),0),lv_1var),lv_1var)))
	_s.add(ForAll([_y53,msg_sender],lv_2var1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y53),msg_sender))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(((total <= 100)==(True)),d1FaddressTuint256mapping(EtherStore_balances(_y53),msg_sender),d1FaddressTuint256mapping(EtherStore_balances(_y53),msg_sender))),0),lv_2var),lv_2var)))
	_s.add(ForAll([_y54,msg_sender],_5reentrancy_verifier1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y54),msg_sender))>(0)),1,0),0)))
	_s.add(ForAll([_y55,msg_sender],_6reentrancy_verifier1==If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y55),msg_sender))>(0)),If(((total <= 100)==(True)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y55),msg_sender))>(0)),1,0),0),0),0)))
	_s.add(ForAll([_y56,msg_sender],And(((total <= 100)==(True)),((d1FaddressTuint256mapping(EtherStore_balances(_y56),msg_sender))>(0)))))
	_s.add(Not(And((_5reentrancy_verifier1==1),(_6reentrancy_verifier1==1))))
except Exception as e:
	print("Error1(Z3Query)"+str(e))
	sys.exit(1)
try:
	result=_s.check()
	if sat==result:
		print("Counter Example")
		print (_s.model())
	elif unsat==result:
		print ("Successfully Proved")
	else:
		print("Failed To Prove")
except Exception as e:
	print("Error2(Z3Query)"+str(e))
	sys.exit(1)